diff -urN -x compile -x LINT vendor/freebsd/src/sys/amd64/conf/BENCHMARK user/rwatson/tcp/src/sys/amd64/conf/BENCHMARK
--- vendor/freebsd/src/sys/amd64/conf/BENCHMARK	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/amd64/conf/BENCHMARK	2010-04-12 20:00:13.845348626 +0100
@@ -0,0 +1,8 @@
+include GENERIC
+ident BENCHMARK
+
+nooptions DEADLKRES            
+nooptions INVARIANTS           
+nooptions INVARIANT_SUPPORT    
+nooptions WITNESS              
+nooptions WITNESS_SKIPSPIN     
diff -urN -x compile -x LINT vendor/freebsd/src/sys/amd64/conf/GENERIC user/rwatson/tcp/src/sys/amd64/conf/GENERIC
--- vendor/freebsd/src/sys/amd64/conf/GENERIC	2011-02-01 09:35:49.147243136 +0000
+++ user/rwatson/tcp/src/sys/amd64/conf/GENERIC	2010-05-22 11:56:29.963634527 +0100
@@ -68,6 +68,8 @@
 options 	INCLUDE_CONFIG_FILE     # Include this file in kernel
 
 # Debugging for use in -current
+options 	ALT_BREAK_TO_DEBUGGER
+options 	BREAK_TO_DEBUGGER
 options 	KDB			# Enable kernel debugger support.
 options 	DDB			# Support DDB.
 options 	GDB			# Support remote GDB.
diff -urN -x compile -x LINT vendor/freebsd/src/sys/amd64/conf/PCBGROUP user/rwatson/tcp/src/sys/amd64/conf/PCBGROUP
--- vendor/freebsd/src/sys/amd64/conf/PCBGROUP	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/amd64/conf/PCBGROUP	2011-01-30 14:25:50.013663875 +0000
@@ -0,0 +1,4 @@
+include GENERIC
+ident PCBGROUP
+
+options PCBGROUP
diff -urN -x compile -x LINT vendor/freebsd/src/sys/amd64/conf/RSS user/rwatson/tcp/src/sys/amd64/conf/RSS
--- vendor/freebsd/src/sys/amd64/conf/RSS	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/amd64/conf/RSS	2011-01-30 14:25:50.013663875 +0000
@@ -0,0 +1,4 @@
+include PCBGROUP
+ident RSS
+
+options RSS
diff -urN -x compile -x LINT vendor/freebsd/src/sys/conf/files user/rwatson/tcp/src/sys/conf/files
--- vendor/freebsd/src/sys/conf/files	2011-02-01 09:36:10.043414577 +0000
+++ user/rwatson/tcp/src/sys/conf/files	2011-02-02 16:48:26.283953244 +0000
@@ -2499,9 +2499,11 @@
 netinet/ip_id.c			optional inet
 netinet/in_mcast.c		optional inet
 netinet/in_pcb.c		optional inet
+netinet/in_pcbgroup.c		optional inet
 netinet/in_proto.c		optional inet \
 	compile-with "${NORMAL_C} -I$S/contrib/pf"
 netinet/in_rmx.c		optional inet
+netinet/in_rss.c		optional inet rss
 netinet/ip_divert.c		optional inet ipdivert ipfirewall
 netinet/ipfw/dn_heap.c		optional inet dummynet
 netinet/ipfw/dn_sched_fifo.c	optional inet dummynet
@@ -2557,6 +2559,7 @@
 netinet/tcp_timer.c		optional inet
 netinet/tcp_timewait.c		optional inet
 netinet/tcp_usrreq.c		optional inet
+netinet/toeplitz.c		optional inet rss
 netinet/udp_usrreq.c		optional inet
 netinet/libalias/alias.c	optional libalias inet | netgraph_nat inet
 netinet/libalias/alias_db.c	optional libalias inet | netgraph_nat inet
@@ -2573,6 +2576,7 @@
 netinet6/in6_ifattach.c		optional inet6
 netinet6/in6_mcast.c		optional inet6
 netinet6/in6_pcb.c		optional inet6
+netinet6/in6_pcbgroup.c		optional inet6 pcbgroup
 netinet6/in6_proto.c		optional inet6
 netinet6/in6_rmx.c		optional inet6
 netinet6/in6_src.c		optional inet6
diff -urN -x compile -x LINT vendor/freebsd/src/sys/conf/options user/rwatson/tcp/src/sys/conf/options
--- vendor/freebsd/src/sys/conf/options	2011-02-01 09:36:10.273637133 +0000
+++ user/rwatson/tcp/src/sys/conf/options	2011-01-30 14:25:50.823549489 +0000
@@ -386,6 +386,7 @@
 ETHER_II		opt_ef.h
 ETHER_SNAP		opt_ef.h
 INET			opt_inet.h
+INET_NOSTATS		opt_inet.h
 INET6			opt_inet6.h
 IPDIVERT
 IPFILTER		opt_ipfilter.h
@@ -414,8 +415,10 @@
 NCP
 NETATALK		opt_atalk.h
 NFSLOCKD
+PCBGROUP		opt_pcbgroup.h
 RADIX_MPATH		opt_mpath.h
 ROUTETABLES		opt_route.h
+RSS			opt_rss.h
 SLIP_IFF_OPTS		opt_slip.h
 TCPDEBUG
 TCP_OFFLOAD_DISABLE	opt_inet.h #Disable code to dispatch tcp offloading
diff -urN -x compile -x LINT vendor/freebsd/src/sys/contrib/pf/net/pf.c user/rwatson/tcp/src/sys/contrib/pf/net/pf.c
--- vendor/freebsd/src/sys/contrib/pf/net/pf.c	2011-02-01 09:36:26.883481122 +0000
+++ user/rwatson/tcp/src/sys/contrib/pf/net/pf.c	2011-02-01 09:49:38.183422874 +0000
@@ -3032,16 +3032,18 @@
 #ifdef INET
 	case AF_INET:
 #ifdef __FreeBSD__
-		INP_INFO_RLOCK(pi);	/* XXX LOR */
-		inp = in_pcblookup_hash(pi, saddr->v4, sport, daddr->v4,
-			dport, 0, NULL);
+		/*
+		 * XXXRW: would be nice if we had an mbuf here so that we
+		 * could use in_pcblookup_mbuf().
+		 */
+		inp = in_pcblookup(pi, saddr->v4, sport, daddr->v4,
+			dport, INPLOOKUP_RLOCKPCB, NULL);
 		if (inp == NULL) {
-			inp = in_pcblookup_hash(pi, saddr->v4, sport,
-			   daddr->v4, dport, INPLOOKUP_WILDCARD, NULL);
-			if(inp == NULL) {
-				INP_INFO_RUNLOCK(pi);
+			inp = in_pcblookup(pi, saddr->v4, sport,
+			   daddr->v4, dport, INPLOOKUP_WILDCARD |
+			   INPLOOKUP_RLOCKPCB, NULL);
+			if (inp == NULL)
 				return (-1);
-			}
 		}
 #else
 		inp = in_pcbhashlookup(tb, saddr->v4, sport, daddr->v4, dport);
@@ -3056,16 +3058,18 @@
 #ifdef INET6
 	case AF_INET6:
 #ifdef __FreeBSD__
-		INP_INFO_RLOCK(pi);
-		inp = in6_pcblookup_hash(pi, &saddr->v6, sport,
-			&daddr->v6, dport, 0, NULL);
+		/*
+		 * XXXRW: would be nice if we had an mbuf here so that we
+		 * could use in6_pcblookup_mbuf().
+		 */
+		inp = in6_pcblookup(pi, &saddr->v6, sport,
+			&daddr->v6, dport, INPLOOKUP_RLOCKPCB, NULL);
 		if (inp == NULL) {
-			inp = in6_pcblookup_hash(pi, &saddr->v6, sport,
-			&daddr->v6, dport, INPLOOKUP_WILDCARD, NULL);
-			if (inp == NULL) {
-				INP_INFO_RUNLOCK(pi);
+			inp = in6_pcblookup(pi, &saddr->v6, sport,
+			    &daddr->v6, dport, INPLOOKUP_WILDCARD |
+			    INPLOOKUP_RLOCKPCB, NULL);
+			if (inp == NULL)
 				return (-1);
-			}
 		}
 #else
 		inp = in6_pcbhashlookup(tb, &saddr->v6, sport, &daddr->v6,
@@ -3083,9 +3087,10 @@
 		return (-1);
 	}
 #ifdef __FreeBSD__
+	INP_RLOCK_ASSERT(inp);
 	pd->lookup.uid = inp->inp_cred->cr_uid;
 	pd->lookup.gid = inp->inp_cred->cr_groups[0];
-	INP_INFO_RUNLOCK(pi);
+	INP_RUNLOCK(inp);
 #else
 	pd->lookup.uid = inp->inp_socket->so_euid;
 	pd->lookup.gid = inp->inp_socket->so_egid;
diff -urN -x compile -x LINT vendor/freebsd/src/sys/dev/cxgb/common/cxgb_common.h user/rwatson/tcp/src/sys/dev/cxgb/common/cxgb_common.h
--- vendor/freebsd/src/sys/dev/cxgb/common/cxgb_common.h	2011-02-01 09:36:55.213488427 +0000
+++ user/rwatson/tcp/src/sys/dev/cxgb/common/cxgb_common.h	2010-06-11 21:32:48.862294497 +0100
@@ -735,6 +735,8 @@
 void t3_config_rss(adapter_t *adapter, unsigned int rss_config, const u8 *cpus,
 		   const u16 *rspq);
 int t3_read_rss(adapter_t *adapter, u8 *lkup, u16 *map);
+void t3_config_rss_secret(adapter_t *adapter, u8 *keyp);
+void t3_read_rss_secret(adapter_t *adapter, u8 *keyp);
 int t3_set_proto_sram(adapter_t *adap, const u8 *data);
 int t3_mps_set_active_ports(adapter_t *adap, unsigned int port_mask);
 void t3_port_failover(adapter_t *adapter, int port);
diff -urN -x compile -x LINT vendor/freebsd/src/sys/dev/cxgb/common/cxgb_t3_hw.c user/rwatson/tcp/src/sys/dev/cxgb/common/cxgb_t3_hw.c
--- vendor/freebsd/src/sys/dev/cxgb/common/cxgb_t3_hw.c	2011-02-01 09:36:55.873447165 +0000
+++ user/rwatson/tcp/src/sys/dev/cxgb/common/cxgb_t3_hw.c	2010-06-11 21:32:49.610301855 +0100
@@ -2990,6 +2990,41 @@
 }
 
 /**
+ *	t3_config_rss_secret - write RSS key
+ *	@adapter: the adapter
+ *	@keyp: the 16-byte RSS key
+ *
+ *	Writes the RSS hash key.
+ */
+void t3_config_rss_secret(adapter_t *adapter, u8 *keyp)
+{
+	const u32 *buf = (const u32 *)keyp;
+
+	t3_write_reg(adapter, A_TP_RSS_SECRET_KEY3, cpu_to_be32(*buf++));
+	t3_write_reg(adapter, A_TP_RSS_SECRET_KEY2, cpu_to_be32(*buf++));
+	t3_write_reg(adapter, A_TP_RSS_SECRET_KEY1, cpu_to_be32(*buf++));
+	t3_write_reg(adapter, A_TP_RSS_SECRET_KEY0, cpu_to_be32(*buf++));
+}
+
+/**
+ *	tr_read_rss_secret - read RSS key
+ *	@adapter: the adapter
+ *	@keyp: storage for the retrieved 16-byte RSS key
+ *
+ *	Reads the RSS hash key.
+ */
+void t3_read_rss_secret(adapter_t *adapter, u8 *keyp)
+{
+	u32 *buf = (u32 *)keyp;
+
+	*buf++ = be32_to_cpu(t3_read_reg(adapter, A_TP_RSS_SECRET_KEY3));
+	*buf++ = be32_to_cpu(t3_read_reg(adapter, A_TP_RSS_SECRET_KEY2));
+	*buf++ = be32_to_cpu(t3_read_reg(adapter, A_TP_RSS_SECRET_KEY1));
+	*buf++ = be32_to_cpu(t3_read_reg(adapter, A_TP_RSS_SECRET_KEY0));
+}
+
+
+/**
  *	t3_tp_set_offload_mode - put TP in NIC/offload mode
  *	@adap: the adapter
  *	@enable: 1 to select offload mode, 0 for regular NIC
diff -urN -x compile -x LINT vendor/freebsd/src/sys/dev/cxgb/cxgb_main.c user/rwatson/tcp/src/sys/dev/cxgb/cxgb_main.c
--- vendor/freebsd/src/sys/dev/cxgb/cxgb_main.c	2011-02-01 09:36:56.167156002 +0000
+++ user/rwatson/tcp/src/sys/dev/cxgb/cxgb_main.c	2011-01-30 14:25:51.403405030 +0000
@@ -27,6 +27,8 @@
 
 ***************************************************************************/
 
+#include "opt_rss.h"
+
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/sys/dev/cxgb/cxgb_main.c,v 1.112 2010/06/07 08:23:16 np Exp $");
 
@@ -66,6 +68,7 @@
 
 #include <netinet/in_systm.h>
 #include <netinet/in.h>
+#include <netinet/in_rss.h>
 #include <netinet/if_ether.h>
 #include <netinet/ip.h>
 #include <netinet/ip.h>
@@ -1425,9 +1428,24 @@
 {
 	int i;
 	u_int nq[2]; 
+#ifdef RSS
+	uint8_t key[RSS_KEYSIZE];
+#endif
 	uint8_t cpus[SGE_QSETS + 1];
 	uint16_t rspq_map[RSS_TABLE_SIZE];
-	
+
+#ifdef RSS
+	/*
+	 * XXXRW: Implicit assumption that RSS_KEYSIZE >= the size of the key
+	 * written by t3_config_rss_secret().
+	 *
+	 * XXXRW: need to program rspq array.
+	 *
+	 * XXXRW: need to program cpu array.
+	 */
+	rss_getkey(key);
+	t3_config_rss_secret(adap, key);
+#endif
 	for (i = 0; i < SGE_QSETS; ++i)
 		cpus[i] = i;
 	cpus[SGE_QSETS] = 0xff;
diff -urN -x compile -x LINT vendor/freebsd/src/sys/dev/cxgb/cxgb_osdep.h user/rwatson/tcp/src/sys/dev/cxgb/cxgb_osdep.h
--- vendor/freebsd/src/sys/dev/cxgb/cxgb_osdep.h	2011-02-01 09:36:56.203398318 +0000
+++ user/rwatson/tcp/src/sys/dev/cxgb/cxgb_osdep.h	2010-06-11 21:32:49.740313631 +0100
@@ -201,6 +201,7 @@
 #define max_t(type, a, b) (type)max((a), (b))
 #define net_device ifnet
 #define cpu_to_be32            htobe32
+#define be32_to_cpu            be32toh
 
 /* Standard PHY definitions */
 #define BMCR_LOOPBACK		BMCR_LOOP
diff -urN -x compile -x LINT vendor/freebsd/src/sys/dev/cxgb/cxgb_sge.c user/rwatson/tcp/src/sys/dev/cxgb/cxgb_sge.c
--- vendor/freebsd/src/sys/dev/cxgb/cxgb_sge.c	2011-02-01 09:36:56.334801890 +0000
+++ user/rwatson/tcp/src/sys/dev/cxgb/cxgb_sge.c	2010-10-19 06:25:31.591604613 +0100
@@ -2975,6 +2975,7 @@
 		uint32_t flags = ntohl(r->flags);
 		uint32_t rss_csum = *(const uint32_t *)r;
 		uint32_t rss_hash = be32toh(r->rss_hdr.rss_hash_val);
+		uint8_t hash_type = r->rss_hdr.hash_type;
 		
 		eth = (r->rss_hdr.opcode == CPL_RX_PKT);
 		
@@ -3024,8 +3025,31 @@
 			
 			eop = get_packet(adap, drop_thresh, qs, &rspq->rspq_mh, r);
 			if (eop) {
-				rspq->rspq_mh.mh_head->m_flags |= M_FLOWID;
-				rspq->rspq_mh.mh_head->m_pkthdr.flowid = rss_hash;
+				struct mbuf *m = rspq->rspq_mh.mh_head;
+
+				if (hash_type) {
+					m->m_flags |= M_FLOWID;
+					m->m_pkthdr.flowid = rss_hash;
+				}
+				switch (hash_type) {
+				case 0:
+					M_HASHTYPE_SET(m, M_HASHTYPE_NONE);
+					break;
+
+				case 1:
+					M_HASHTYPE_SET(m,
+					    M_HASHTYPE_RSS_2TUPLE);
+					break;
+
+				case 2:
+					M_HASHTYPE_SET(m,
+					    M_HASHTYPE_RSS_4TUPLE);
+					break;
+
+				case 3:
+					M_HASHTYPE_SET(m, M_HASHTYPE_OPAQUE);
+					break;
+				}
 			}
 			
 			ethpad = 2;
diff -urN -x compile -x LINT vendor/freebsd/src/sys/i386/conf/LINT-VIMAGE user/rwatson/tcp/src/sys/i386/conf/LINT-VIMAGE
--- vendor/freebsd/src/sys/i386/conf/LINT-VIMAGE	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/i386/conf/LINT-VIMAGE	2010-11-13 21:16:38.914821461 +0000
@@ -0,0 +1,3 @@
+include LINT
+ident LINT-VIMAGE
+options VIMAGE
diff -urN -x compile -x LINT vendor/freebsd/src/sys/i386/conf/PCBGROUP user/rwatson/tcp/src/sys/i386/conf/PCBGROUP
--- vendor/freebsd/src/sys/i386/conf/PCBGROUP	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/i386/conf/PCBGROUP	2011-01-30 14:25:51.513676866 +0000
@@ -0,0 +1,4 @@
+include GENERIC
+ident PCBGROUP
+
+options PCBGROUP
diff -urN -x compile -x LINT vendor/freebsd/src/sys/i386/conf/RSS user/rwatson/tcp/src/sys/i386/conf/RSS
--- vendor/freebsd/src/sys/i386/conf/RSS	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/i386/conf/RSS	2011-02-01 09:02:14.733492227 +0000
@@ -0,0 +1,4 @@
+include PCBGROUP
+ident RSS
+
+options RSS
diff -urN -x compile -x LINT vendor/freebsd/src/sys/modules/cxgb/cxgb/Makefile user/rwatson/tcp/src/sys/modules/cxgb/cxgb/Makefile
--- vendor/freebsd/src/sys/modules/cxgb/cxgb/Makefile	2011-02-01 09:38:33.174677349 +0000
+++ user/rwatson/tcp/src/sys/modules/cxgb/cxgb/Makefile	2010-10-18 17:08:38.081813566 +0100
@@ -8,7 +8,7 @@
 SRCS+=	cxgb_xgmac.c cxgb_vsc7323.c cxgb_t3_hw.c cxgb_main.c cxgb_aq100x.c
 SRCS+=  cxgb_sge.c cxgb_offload.c cxgb_tn1010.c
 SRCS+=	device_if.h bus_if.h pci_if.h
-SRCS+=	opt_inet.h opt_zero.h opt_sched.h
+SRCS+=	opt_inet.h opt_rss.h opt_zero.h opt_sched.h
 SRCS+=	uipc_mvec.c
 
 CFLAGS+= -g -DDEFAULT_JUMBO -I${CXGB}
diff -urN -x compile -x LINT vendor/freebsd/src/sys/net/if_ethersubr.c user/rwatson/tcp/src/sys/net/if_ethersubr.c
--- vendor/freebsd/src/sys/net/if_ethersubr.c	2011-02-01 09:38:34.773490048 +0000
+++ user/rwatson/tcp/src/sys/net/if_ethersubr.c	2011-02-01 08:30:17.343401866 +0000
@@ -37,6 +37,7 @@
 #include "opt_netgraph.h"
 #include "opt_carp.h"
 #include "opt_mbuf_profiling.h"
+#include "opt_rss.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -70,6 +71,7 @@
 #include <netinet/in.h>
 #include <netinet/in_var.h>
 #include <netinet/if_ether.h>
+#include <netinet/in_rss.h>
 #include <netinet/ip_var.h>
 #include <netinet/ip_fw.h>
 #include <netinet/ipfw/ip_fw_private.h>
@@ -112,6 +114,9 @@
 CTASSERT(sizeof (struct ether_addr) == ETHER_ADDR_LEN);
 #endif
 
+SYSCTL_DECL(_net_link);
+SYSCTL_NODE(_net_link, IFT_ETHER, ether, CTLFLAG_RW, 0, "Ethernet");
+
 /* netgraph node hooks for ng_ether(4) */
 void	(*ng_ether_input_p)(struct ifnet *ifp, struct mbuf **mp);
 void	(*ng_ether_input_orphan_p)(struct ifnet *ifp, struct mbuf *m);
@@ -566,7 +571,7 @@
  * mbuf chain m with the ethernet header at the front.
  */
 static void
-ether_input(struct ifnet *ifp, struct mbuf *m)
+ether_input_internal(struct ifnet *ifp, struct mbuf *m)
 {
 	struct ether_header *eh;
 	u_short etype;
@@ -761,6 +766,74 @@
 	CURVNET_RESTORE();
 }
 
+#ifdef RSS
+/*
+ * Ethernet input dispatch; by default, direct dispatch here regardless of
+ * global configuration.  However, if RSS is enabled, hook up RSS affinity
+ * so that when deferred or hybrid dispatch is enabled, we can redistribute
+ * load based on RSS.
+ *
+ * XXXRW: Would be nice if the ifnet passed up a flag indicating whether or
+ * not it had already done work distribution via multi-queue.  Then we could
+ * direct dispatch in the event load balancing was already complete and
+ * handle the case of interfaces with different capabilities better.
+ *
+ * XXXRW: Sort of want an M_DISTRIBUTED flag to avoid multiple distributions
+ * at multiple layers?
+ *
+ * XXXRW: For now, enable all this only if RSS is compiled in, although it
+ * works fine without RSS.  Need to characterise the performance overhead
+ * of the detour through the netisr code in the event the result is always
+ * direct dispatch.
+ */
+static void
+ether_nh_input(struct mbuf *m)
+{
+
+	ether_input_internal(m->m_pkthdr.rcvif, m);
+}
+
+static struct netisr_handler	ether_nh = {
+	.nh_name = "ether",
+	.nh_handler = ether_nh_input,
+	.nh_proto = NETISR_ETHER,
+#ifdef RSS
+	.nh_policy = NETISR_POLICY_CPU,
+	.nh_dispatch = NETISR_DISPATCH_DIRECT,
+	.nh_m2cpuid = rss_m2cpuid,
+#else
+	.nh_policy = NETISR_POLICY_SOURCE,
+	.nh_dispatch = NETISR_DISPATCH_DIRECT,
+#endif
+};
+
+static void
+ether_init(__unused void *arg)
+{
+
+	netisr_register(&ether_nh);
+}
+SYSINIT(ether, SI_SUB_PSEUDO, SI_ORDER_ANY, ether_init, NULL);
+#endif /* RSS */
+
+static void
+ether_input(struct ifnet *ifp, struct mbuf *m)
+{
+
+#ifdef RSS
+	/*
+	 * We will rely on rcvif being set properly in the deferred context,
+	 * so assert it is correct here.  Arguably, this should be asserted
+	 * for all cases, not just the RSS case.
+	 */
+	KASSERT(m->m_pkthdr.rcvif == ifp, ("ether_input: ifnet mismatch"));
+
+	netisr_dispatch(NETISR_ETHER, m);
+#else
+	ether_input_internal(ifp, m);
+#endif
+}
+
 /*
  * Upper layer processing for a received Ethernet packet.
  */
@@ -993,8 +1066,6 @@
 	if_detach(ifp);
 }
 
-SYSCTL_DECL(_net_link);
-SYSCTL_NODE(_net_link, IFT_ETHER, ether, CTLFLAG_RW, 0, "Ethernet");
 #if defined(INET) || defined(INET6)
 SYSCTL_VNET_INT(_net_link_ether, OID_AUTO, ipfw, CTLFLAG_RW,
 	     &VNET_NAME(ether_ipfw), 0, "Pass ether pkts through firewall");
